FIX: Topology reservation
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function check_prerequisites () {
171
172     # Fail if prerequisites are not met.
173     #
174     # Functions called:
175     # - installed - Check if application is installed/present in system.
176     # - die - Print to stderr and exit.
177
178     set -exuo pipefail
179
180     if ! installed sshpass; then
181         die "Please install sshpass before continue!"
182     fi
183 }
184
185 function cleanup_topo () {
186
187     # Variables read:
188     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
189     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
190
191     set -exuo pipefail
192
193     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
194     # Not using "|| die" as some callers might want to ignore errors,
195     # e.g. in teardowns, such as unreserve.
196 }
197
198
199 function common_dirs () {
200
201     # Set global variables, create some directories (without touching content).
202
203     # Variables set:
204     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
205     # - CSIT_DIR - Path to existing root of local CSIT git repository.
206     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
207     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
208     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
209     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
210     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
211     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
212     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
213     # Directories created if not present:
214     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
215     # Functions called:
216     # - die - Print to stderr and exit.
217
218     set -exuo pipefail
219
220     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
221         die "Some error during locating of this source file."
222     }
223     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
224         die "Some error during dirname call."
225     }
226     # Current working directory could be in a different repo, e.g. VPP.
227     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
228     relative_csit_dir=$(git rev-parse --show-toplevel) || {
229         die "Git rev-parse failed."
230     }
231     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
232     popd || die "Popd failed."
233     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
234         die "Readlink failed."
235     }
236     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
237         die "Readlink failed."
238     }
239     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
240         die "Readlink failed."
241     }
242     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
243         die "Readlink failed."
244     }
245     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
246         die "Readlink failed."
247     }
248
249     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
250         die "Readlink failed."
251     }
252     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
253     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
254         die "Readlink failed."
255     }
256     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
257     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
258         die "Readlink failed."
259     }
260     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
261 }
262
263
264 function compose_pybot_arguments () {
265
266     # Variables read:
267     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
268     # - DUT - CSIT test/ subdirectory, set while processing tags.
269     # - TAGS - Array variable holding selected tag boolean expressions.
270     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
271     # - TEST_CODE - The test selection string from environment or argument.
272     # Variables set:
273     # - PYBOT_ARGS - String holding part of all arguments for pybot.
274     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
275
276     set -exuo pipefail
277
278     # No explicit check needed with "set -u".
279     PYBOT_ARGS=("--loglevel" "TRACE")
280     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
281
282     case "${TEST_CODE}" in
283         *"device"*)
284             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
285             ;;
286         *"func"*)
287             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
288             ;;
289         *"perf"*)
290             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
291             ;;
292         *)
293             die "Unknown specification: ${TEST_CODE}"
294     esac
295
296     EXPANDED_TAGS=()
297     for tag in "${TAGS[@]}"; do
298         if [[ ${tag} == "!"* ]]; then
299             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
300         else
301             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
302         fi
303     done
304 }
305
306
307 function copy_archives () {
308
309     # Create additional archive if workspace variable is set.
310     # This way if script is running in jenkins all will be
311     # automatically archived to logs.fd.io.
312     #
313     # Variables read:
314     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
315     #   Can be unset, then it speeds up manual testing.
316     # - ARCHIVE_DIR - Path to directory with content to be copied.
317     # Directories updated:
318     # - ${WORKSPACE}/archives/ - Created if does not exist.
319     #   Content of ${ARCHIVE_DIR}/ is copied here.
320     # Functions called:
321     # - die - Print to stderr and exit.
322
323     set -exuo pipefail
324
325     if [[ -n "${WORKSPACE-}" ]]; then
326         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
327         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
328     fi
329 }
330
331
332 function deactivate_docker_topology () {
333
334     # Deactivate virtual vpp-device topology by removing containers.
335     #
336     # Variables read:
337     # - NODENESS - Node multiplicity of desired testbed.
338     # - FLAVOR - Node flavor string, usually describing the processor.
339
340     set -exuo pipefail
341
342     case_text="${NODENESS}_${FLAVOR}"
343     case "${case_text}" in
344         "1n_skx" | "1n_tx2")
345             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
346             ssh="ssh root@${hostname} -p 6022"
347             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
348             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
349                 die "Topology cleanup via shim-dcr failed!"
350             }
351             ;;
352         "1n_vbox")
353             enter_mutex || die
354             clean_environment || {
355                 die "Topology cleanup locally failed!"
356             }
357             exit_mutex || die
358             ;;
359         *)
360             die "Unknown specification: ${case_text}!"
361     esac
362 }
363
364
365 function die () {
366
367     # Print the message to standard error end exit with error code specified
368     # by the second argument.
369     #
370     # Hardcoded values:
371     # - The default error message.
372     # Arguments:
373     # - ${1} - The whole error message, be sure to quote. Optional
374     # - ${2} - the code to exit with, default: 1.
375
376     set -x
377     set +eu
378     warn "${1:-Unspecified run-time error occurred!}"
379     exit "${2:-1}"
380 }
381
382
383 function die_on_pybot_error () {
384
385     # Source this fragment if you want to abort on any failed test case.
386     #
387     # Variables read:
388     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
389     # Functions called:
390     # - die - Print to stderr and exit.
391
392     set -exuo pipefail
393
394     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
395         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
396     fi
397 }
398
399
400 function generate_tests () {
401
402     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
403     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
404     # The generation is done by executing any *.py executable
405     # within any subdirectory after copying.
406
407     # This is a separate function, because this code is called
408     # both by autogen checker and entries calling run_pybot.
409
410     # Directories read:
411     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
412     # Directories replaced:
413     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
414
415     set -exuo pipefail
416
417     rm -rf "${GENERATED_DIR}/tests" || die
418     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
419     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
420     cmd_line+=("-executable" "-name" "*.py")
421     file_list=$("${cmd_line[@]}") || die
422
423     for gen in ${file_list}; do
424         directory="$(dirname "${gen}")" || die
425         filename="$(basename "${gen}")" || die
426         pushd "${directory}" || die
427         ./"${filename}" || die
428         popd || die
429     done
430 }
431
432
433 function get_test_code () {
434
435     # Arguments:
436     # - ${1} - Optional, argument of entry script (or empty as unset).
437     #   Test code value to override job name from environment.
438     # Variables read:
439     # - JOB_NAME - String affecting test selection, default if not argument.
440     # Variables set:
441     # - TEST_CODE - The test selection string from environment or argument.
442     # - NODENESS - Node multiplicity of desired testbed.
443     # - FLAVOR - Node flavor string, usually describing the processor.
444
445     set -exuo pipefail
446
447     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
448     if [[ -z "${TEST_CODE}" ]]; then
449         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
450     fi
451
452     case "${TEST_CODE}" in
453         *"1n-vbox"*)
454             NODENESS="1n"
455             FLAVOR="vbox"
456             ;;
457         *"1n-skx"*)
458             NODENESS="1n"
459             FLAVOR="skx"
460             ;;
461        *"1n-tx2"*)
462             NODENESS="1n"
463             FLAVOR="tx2"
464             ;;
465         *"2n-skx"*)
466             NODENESS="2n"
467             FLAVOR="skx"
468             ;;
469         *"3n-skx"*)
470             NODENESS="3n"
471             FLAVOR="skx"
472             ;;
473         *"2n-dnv"*)
474             NODENESS="2n"
475             FLAVOR="dnv"
476             ;;
477         *"3n-dnv"*)
478             NODENESS="3n"
479             FLAVOR="dnv"
480             ;;
481         *"3n-tsh"*)
482             NODENESS="3n"
483             FLAVOR="tsh"
484             ;;
485         *)
486             # Fallback to 3-node Haswell by default (backward compatibility)
487             NODENESS="3n"
488             FLAVOR="hsw"
489             ;;
490     esac
491 }
492
493
494 function get_test_tag_string () {
495
496     # Variables read:
497     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
498     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
499     # - TEST_CODE - The test selection string from environment or argument.
500     # Variables set:
501     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
502     #   May be empty, not set on event types not adding comment.
503
504     # TODO: ci-management scripts no longer need to perform this.
505
506     set -exuo pipefail
507
508     trigger=""
509     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
510         case "${TEST_CODE}" in
511             *"device"*)
512                 # On parsing error, ${trigger} stays empty.
513                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
514                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)')" \
515                     || true
516                 # Set test tags as string.
517                 TEST_TAG_STRING="${trigger#$"devicetest"}"
518                 ;;
519             *"perf"*)
520                 # On parsing error, ${trigger} stays empty.
521                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
522                 # As "perftest" can be followed by something, we substitute it.
523                 comment="${comment/perftest-2n/perftest}"
524                 comment="${comment/perftest-3n/perftest}"
525                 comment="${comment/perftest-hsw/perftest}"
526                 comment="${comment/perftest-skx/perftest}"
527                 comment="${comment/perftest-dnv/perftest}"
528                 comment="${comment/perftest-tsh/perftest}"
529                 tag_string="$(echo "${comment}" \
530                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
531                 # Set test tags as string.
532                 TEST_TAG_STRING="${tag_string#$"perftest"}"
533                 ;;
534             *)
535                 die "Unknown specification: ${TEST_CODE}"
536         esac
537     fi
538 }
539
540
541 function installed () {
542
543     # Check if the given utility is installed. Fail if not installed.
544     #
545     # Duplicate of common.sh function, as this file is also used standalone.
546     #
547     # Arguments:
548     # - ${1} - Utility to check.
549     # Returns:
550     # - 0 - If command is installed.
551     # - 1 - If command is not installed.
552
553     set -exuo pipefail
554
555     command -v "${1}"
556 }
557
558
559 function reserve_and_cleanup_testbed () {
560
561     # Reserve physical testbed, perform cleanup, register trap to unreserve.
562     # When cleanup fails, remove from topologies and keep retrying
563     # until all topologies are removed.
564     #
565     # Variables read:
566     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
567     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
568     # - BUILD_TAG - Any string suitable as filename, identifying
569     #   test run executing this function. May be unset.
570     # Variables set:
571     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
572     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
573     # Functions called:
574     # - die - Print to stderr and exit.
575     # Traps registered:
576     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
577
578     set -exuo pipefail
579
580     while true; do
581         for topo in "${TOPOLOGIES[@]}"; do
582             set +e
583             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
584             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
585             python "${scrpt}" "${opts[@]}"
586             result="$?"
587             set -e
588             if [[ "${result}" == "0" ]]; then
589                 # Trap unreservation before cleanup check,
590                 # so multiple jobs showing failed cleanup improve chances
591                 # of humans to notice and fix.
592                 WORKING_TOPOLOGY="${topo}"
593                 echo "Reserved: ${WORKING_TOPOLOGY}"
594                 trap "untrap_and_unreserve_testbed" EXIT || {
595                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
596                     untrap_and_unreserve_testbed "${message}" || {
597                         die "Teardown should have died, not failed."
598                     }
599                     die "Trap attempt failed, unreserve succeeded. Aborting."
600                 }
601                 # Cleanup check.
602                 set +e
603                 cleanup_topo
604                 result="$?"
605                 set -e
606                 if [[ "${result}" == "0" ]]; then
607                     break
608                 fi
609                 warn "Testbed cleanup failed: ${topo}"
610                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
611             fi
612             # Else testbed is accessible but currently reserved, moving on.
613         done
614
615         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
616             # Exit the infinite while loop if we made a reservation.
617             warn "Reservation and cleanup successful."
618             break
619         fi
620
621         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
622             die "Run out of operational testbeds!"
623         fi
624
625         # Wait ~3minutes before next try.
626         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
627             die "Sleep time calculation failed."
628         }
629         echo "Sleeping ${sleep_time}"
630         sleep "${sleep_time}" || die "Sleep failed."
631     done
632 }
633
634
635 function run_pybot () {
636
637     # Run pybot with options based on input variables. Create output_info.xml
638     #
639     # Variables read:
640     # - CSIT_DIR - Path to existing root of local CSIT git repository.
641     # - ARCHIVE_DIR - Path to store robot result files in.
642     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
643     # - GENERATED_DIR - Tests are assumed to be generated under there.
644     # Variables set:
645     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
646     # Functions called:
647     # - die - Print to stderr and exit.
648
649     set -exuo pipefail
650
651     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
652     all_options+=("--noncritical" "EXPECTED_FAILING")
653     all_options+=("${EXPANDED_TAGS[@]}")
654
655     pushd "${CSIT_DIR}" || die "Change directory operation failed."
656     set +e
657     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
658     PYBOT_EXIT_STATUS="$?"
659     set -e
660
661     # Generate INFO level output_info.xml for post-processing.
662     all_options=("--loglevel" "INFO")
663     all_options+=("--log" "none")
664     all_options+=("--report" "none")
665     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
666     all_options+=("${ARCHIVE_DIR}/output.xml")
667     rebot "${all_options[@]}" || true
668     popd || die "Change directory operation failed."
669 }
670
671
672 function select_arch_os () {
673
674     # Set variables affected by local CPU architecture and operating system.
675     #
676     # Variables set:
677     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
678     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
679     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
680
681     set -exuo pipefail
682
683     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
684         die "Get OS release failed."
685     }
686
687     case "${os_id}" in
688         "ubuntu"*)
689             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
690             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
691             PKG_SUFFIX="deb"
692             ;;
693         "centos"*)
694             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
695             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
696             PKG_SUFFIX="rpm"
697             ;;
698         *)
699             die "Unable to identify distro or os from ${os_id}"
700             ;;
701     esac
702
703     arch=$(uname -m) || {
704         die "Get CPU architecture failed."
705     }
706
707     case "${arch}" in
708         "aarch64")
709             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
710             ;;
711         *)
712             ;;
713     esac
714 }
715
716
717 function select_tags () {
718
719     # Variables read:
720     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
721     # - TEST_CODE - String affecting test selection, usually jenkins job name.
722     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
723     #   Can be unset.
724     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
725     # - BASH_FUNCTION_DIR - Directory with input files to process.
726     # Variables set:
727     # - TAGS - Array of processed tag boolean expressions.
728
729     set -exuo pipefail
730
731     # NIC SELECTION
732     start_pattern='^  TG:'
733     end_pattern='^ \? \?[A-Za-z0-9]\+:'
734     # Remove the TG section from topology file
735     sed_command="/${start_pattern}/,/${end_pattern}/d"
736     # All topologies DUT NICs
737     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
738                 | grep -hoP "model: \K.*" | sort -u)
739     # Selected topology DUT NICs
740     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
741                | grep -hoP "model: \K.*" | sort -u)
742     # All topologies DUT NICs - Selected topology DUT NICs
743     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
744         die "Computation of excluded NICs failed."
745     }
746
747     # Select default NIC tag.
748     case "${TEST_CODE}" in
749         *"3n-dnv"* | *"2n-dnv"*)
750             default_nic="nic_intel-x553"
751             ;;
752         *"3n-tsh"*)
753             default_nic="nic_intel-x520-da2"
754             ;;
755         *)
756             default_nic="nic_intel-x710"
757             ;;
758     esac
759
760     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
761     # Tag file directory shorthand.
762     tfd="${BASH_FUNCTION_DIR}"
763     case "${TEST_CODE}" in
764         # Select specific performance tests based on jenkins job type variable.
765         *"ndrpdr-weekly"* )
766             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
767             ;;
768         *"mrr-daily"* )
769             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
770                 ${tfd}/mrr-daily-${FLAVOR}.txt) || die
771             ;;
772         *"mrr-weekly"* )
773             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
774             ;;
775         * )
776             if [[ -z "${TEST_TAG_STRING-}" ]]; then
777                 # If nothing is specified, we will run pre-selected tests by
778                 # following tags.
779                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
780                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
781                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
782                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
783                                 "!dot1q" "!drv_avf")
784             else
785                 # If trigger contains tags, split them into array.
786                 test_tag_array=(${TEST_TAG_STRING//:/ })
787             fi
788             ;;
789     esac
790
791     # Blacklisting certain tags per topology.
792     #
793     # Reasons for blacklisting:
794     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
795     # TODO: Add missing reasons here (if general) or where used (if specific).
796     case "${TEST_CODE}" in
797         *"2n-skx"*)
798             test_tag_array+=("!ipsechw")
799             ;;
800         *"3n-skx"*)
801             test_tag_array+=("!ipsechw")
802             # Not enough nic_intel-xxv710 to support double link tests.
803             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
804             ;;
805         *"2n-dnv"*)
806             test_tag_array+=("!ipsechw")
807             test_tag_array+=("!memif")
808             test_tag_array+=("!srv6_proxy")
809             test_tag_array+=("!vhost")
810             test_tag_array+=("!vts")
811             test_tag_array+=("!drv_avf")
812             ;;
813         *"3n-dnv"*)
814             test_tag_array+=("!memif")
815             test_tag_array+=("!srv6_proxy")
816             test_tag_array+=("!vhost")
817             test_tag_array+=("!vts")
818             test_tag_array+=("!drv_avf")
819             ;;
820         *"3n-tsh"*)
821             # 3n-tsh only has x520 NICs which don't work with AVF
822             test_tag_array+=("!drv_avf")
823             test_tag_array+=("!ipsechw")
824             ;;
825         *"3n-hsw"*)
826             # TODO: Introduce NOIOMMU version of AVF tests.
827             # TODO: Make (both) AVF tests work on Haswell,
828             # or document why (some of) it is not possible.
829             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
830             test_tag_array+=("!drv_avf")
831             # All cards have access to QAT. But only one card (xl710)
832             # resides in same NUMA as QAT. Other cards must go over QPI
833             # which we do not want to even run.
834             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
835             ;;
836         *)
837             # Default to 3n-hsw due to compatibility.
838             test_tag_array+=("!drv_avf")
839             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
840             ;;
841     esac
842
843     # We will add excluded NICs.
844     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
845
846     TAGS=()
847
848     # We will prefix with perftest to prevent running other tests
849     # (e.g. Functional).
850     prefix="perftestAND"
851     set +x
852     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
853         # Automatic prefixing for VPP jobs to limit the NIC used and
854         # traffic evaluation to MRR.
855         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
856             prefix="${prefix}mrrAND"
857         else
858             prefix="${prefix}mrrAND${default_nic}AND"
859         fi
860     fi
861     for tag in "${test_tag_array[@]}"; do
862         if [[ "${tag}" == "!"* ]]; then
863             # Exclude tags are not prefixed.
864             TAGS+=("${tag}")
865         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
866             # Empty and comment lines are skipped.
867             # Other lines are normal tags, they are to be prefixed.
868             TAGS+=("${prefix}${tag}")
869         fi
870     done
871     set -x
872 }
873
874
875 function select_topology () {
876
877     # Variables read:
878     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
879     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
880     # - CSIT_DIR - Path to existing root of local CSIT git repository.
881     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
882     # Variables set:
883     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
884     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
885     # Functions called:
886     # - die - Print to stderr and exit.
887
888     set -exuo pipefail
889
890     case_text="${NODENESS}_${FLAVOR}"
891     case "${case_text}" in
892         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
893         # TODO: Double link availability depends on NIC used.
894         "1n_vbox")
895             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
896             TOPOLOGIES_TAGS="2_node_single_link_topo"
897             ;;
898         "1n_skx" | "1n_tx2")
899             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
900             TOPOLOGIES_TAGS="2_node_single_link_topo"
901             ;;
902         "2n_skx")
903             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
904             TOPOLOGIES_TAGS="2_node_*_link_topo"
905             ;;
906         "3n_skx")
907             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
908             TOPOLOGIES_TAGS="3_node_*_link_topo"
909             ;;
910         "2n_dnv")
911             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
912             TOPOLOGIES_TAGS="2_node_single_link_topo"
913             ;;
914         "3n_dnv")
915             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
916             TOPOLOGIES_TAGS="3_node_single_link_topo"
917             ;;
918         "3n_hsw")
919             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
920             TOPOLOGIES_TAGS="3_node_single_link_topo"
921             ;;
922         "3n_tsh")
923             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
924             TOPOLOGIES_TAGS="3_node_single_link_topo"
925             ;;
926         *)
927             # No falling back to 3n_hsw default, that should have been done
928             # by the function which has set NODENESS and FLAVOR.
929             die "Unknown specification: ${case_text}"
930     esac
931
932     if [[ -z "${TOPOLOGIES-}" ]]; then
933         die "No applicable topology found!"
934     fi
935 }
936
937
938 function select_vpp_device_tags () {
939
940     # Variables read:
941     # - TEST_CODE - String affecting test selection, usually jenkins job name.
942     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
943     #   Can be unset.
944     # Variables set:
945     # - TAGS - Array of processed tag boolean expressions.
946
947     set -exuo pipefail
948
949     case "${TEST_CODE}" in
950         # Select specific device tests based on jenkins job type variable.
951         * )
952             if [[ -z "${TEST_TAG_STRING-}" ]]; then
953                 # If nothing is specified, we will run pre-selected tests by
954                 # following tags. Items of array will be concatenated by OR
955                 # in Robot Framework.
956                 test_tag_array=()
957             else
958                 # If trigger contains tags, split them into array.
959                 test_tag_array=(${TEST_TAG_STRING//:/ })
960             fi
961             ;;
962     esac
963
964     # Blacklisting certain tags per topology.
965     #
966     # Reasons for blacklisting:
967     # - avf - AVF is not possible to run on enic driver of VirtualBox.
968     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
969     case "${TEST_CODE}" in
970         *"1n-vbox"*)
971             test_tag_array+=("!avf")
972             test_tag_array+=("!vhost")
973             ;;
974         *)
975             ;;
976     esac
977
978     TAGS=()
979
980     # We will prefix with devicetest to prevent running other tests
981     # (e.g. Functional).
982     prefix="devicetestAND"
983     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
984         # Automatic prefixing for VPP jobs to limit testing.
985         prefix="${prefix}"
986     fi
987     for tag in "${test_tag_array[@]}"; do
988         if [[ ${tag} == "!"* ]]; then
989             # Exclude tags are not prefixed.
990             TAGS+=("${tag}")
991         else
992             TAGS+=("${prefix}${tag}")
993         fi
994     done
995 }
996
997 function untrap_and_unreserve_testbed () {
998
999     # Use this as a trap function to ensure testbed does not remain reserved.
1000     # Perhaps call directly before script exit, to free testbed for other jobs.
1001     # This function is smart enough to avoid multiple unreservations (so safe).
1002     # Topo cleanup is executed (call it best practice), ignoring failures.
1003     #
1004     # Hardcoded values:
1005     # - default message to die with if testbed might remain reserved.
1006     # Arguments:
1007     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1008     # Variables read (by inner function):
1009     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1010     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1011     # Variables written:
1012     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1013     # Trap unregistered:
1014     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1015     # Functions called:
1016     # - die - Print to stderr and exit.
1017
1018     set -xo pipefail
1019     set +eu  # We do not want to exit early in a "teardown" function.
1020     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1021     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1022     if [[ -z "${wt-}" ]]; then
1023         set -eu
1024         warn "Testbed looks unreserved already. Trap removal failed before?"
1025     else
1026         cleanup_topo || true
1027         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1028             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1029         }
1030         WORKING_TOPOLOGY=""
1031         set -eu
1032     fi
1033 }
1034
1035
1036 function warn () {
1037
1038     # Print the message to standard error.
1039     #
1040     # Arguments:
1041     # - ${@} - The text of the message.
1042
1043     set -exuo pipefail
1044
1045     echo "$@" >&2
1046 }